org.apache.lucene.facet.sortedset

## Class ConcurrentSortedSetDocValuesFacetCounts

- java.lang.Object
- - org.apache.lucene.facet.Facets
  - - org.apache.lucene.facet.sortedset.ConcurrentSortedSetDocValuesFacetCounts

-     public class ConcurrentSortedSetDocValuesFacetCounts
      extends Facets

  Like `SortedSetDocValuesFacetCounts`, but aggregates counts concurrently across segments.
  WARNING: This API is experimental and might change in incompatible ways in the next release.

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `ConcurrentSortedSetDocValuesFacetCounts(SortedSetDocValuesReaderState state, ExecutorService exec)` Returns all facet counts, same result as searching on `MatchAllDocsQuery` but faster.
    `ConcurrentSortedSetDocValuesFacetCounts(SortedSetDocValuesReaderState state, FacetsCollector hits, ExecutorService exec)` Counts all facet dimensions across the provided hits.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `List<FacetResult>` | `getAllDims(int topN)` Returns topN labels for any dimension that had hits, sorted by the number of hits that dimension matched; this is used for "sparse" faceting, where many different dimensions were indexed, for example depending on the type of document.
    `Number` | `getSpecificValue(String dim, String... path)` Return the count or value for a specific path.
    `FacetResult` | `getTopChildren(int topN, String dim, String... path)` Returns the topN child labels under the specified path.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### ConcurrentSortedSetDocValuesFacetCounts

          public ConcurrentSortedSetDocValuesFacetCounts(SortedSetDocValuesReaderState state,
                                                         ExecutorService exec)
                                                  throws IOException,
                                                         InterruptedException

      Returns all facet counts, same result as searching on `MatchAllDocsQuery` but faster.
      Throws:
        `IOException`
        `InterruptedException`

    - #### ConcurrentSortedSetDocValuesFacetCounts

          public ConcurrentSortedSetDocValuesFacetCounts(SortedSetDocValuesReaderState state,
                                                         FacetsCollector hits,
                                                         ExecutorService exec)
                                                  throws IOException,
                                                         InterruptedException

      Counts all facet dimensions across the provided hits.
      Throws:
        `IOException`
        `InterruptedException`

  - ### Method Detail

    - #### getTopChildren

          public FacetResult getTopChildren(int topN,
                                            String dim,
                                            String... path)
                                     throws IOException

      Description copied from class: `Facets`
      Returns the topN child labels under the specified path. Returns null if the specified path doesn't exist or if this dimension was never seen.
      Specified by:
        `getTopChildren` in class `Facets`
      Throws:
        `IOException`

    - #### getSpecificValue

          public Number getSpecificValue(String dim,
                                         String... path)
                                  throws IOException

      Description copied from class: `Facets`
      Return the count or value for a specific path. Returns -1 if this path doesn't exist, else the count.
      Specified by:
        `getSpecificValue` in class `Facets`
      Throws:
        `IOException`

    - #### getAllDims

          public List<FacetResult> getAllDims(int topN)
                                       throws IOException

      Description copied from class: `Facets`
      Returns topN labels for any dimension that had hits, sorted by the number of hits that dimension matched; this is used for "sparse" faceting, where many different dimensions were indexed, for example depending on the type of document.
      Specified by:
        `getAllDims` in class `Facets`
      Throws:
        `IOException`

Copyright © 2000-2019 Apache Software Foundation. All Rights Reserved.